/*
 * This file is generated by jOOQ.
 */
package com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.tables;


import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.DefaultSchema;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.Indexes;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.Keys;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.tables.records.DsrStatisticsRecord;

import java.math.BigDecimal;
import java.util.Arrays;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.11.9"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class DsrStatistics extends TableImpl<DsrStatisticsRecord> {

    private static final long serialVersionUID = -1867193036;

    /**
     * The reference instance of <code>DSR_STATISTICS</code>
     */
    public static final DsrStatistics DSR_STATISTICS = new DsrStatistics();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<DsrStatisticsRecord> getRecordType() {
        return DsrStatisticsRecord.class;
    }

    /**
     * The column <code>DSR_STATISTICS.IDDSR</code>.
     */
    public final TableField<DsrStatisticsRecord, String> IDDSR = createField("IDDSR", org.jooq.impl.SQLDataType.VARCHAR(512).nullable(false), this, "");

    /**
     * The column <code>DSR_STATISTICS.TOTAL_LINES</code>.
     */
    public final TableField<DsrStatisticsRecord, Long> TOTAL_LINES = createField("TOTAL_LINES", org.jooq.impl.SQLDataType.BIGINT, this, "");

    /**
     * The column <code>DSR_STATISTICS.TOTAL_RECOGNIZED</code>.
     */
    public final TableField<DsrStatisticsRecord, Long> TOTAL_RECOGNIZED = createField("TOTAL_RECOGNIZED", org.jooq.impl.SQLDataType.BIGINT, this, "");

    /**
     * The column <code>DSR_STATISTICS.TOTAL_IDSONG</code>.
     */
    public final TableField<DsrStatisticsRecord, Long> TOTAL_IDSONG = createField("TOTAL_IDSONG", org.jooq.impl.SQLDataType.BIGINT, this, "");

    /**
     * The column <code>DSR_STATISTICS.TOTAL_ISWC</code>.
     */
    public final TableField<DsrStatisticsRecord, Long> TOTAL_ISWC = createField("TOTAL_ISWC", org.jooq.impl.SQLDataType.BIGINT, this, "");

    /**
     * The column <code>DSR_STATISTICS.TOTAL_ISRC</code>.
     */
    public final TableField<DsrStatisticsRecord, Long> TOTAL_ISRC = createField("TOTAL_ISRC", org.jooq.impl.SQLDataType.BIGINT, this, "");

    /**
     * The column <code>DSR_STATISTICS.TOTAL_TITLE_ARTISTS</code>.
     */
    public final TableField<DsrStatisticsRecord, Long> TOTAL_TITLE_ARTISTS = createField("TOTAL_TITLE_ARTISTS", org.jooq.impl.SQLDataType.BIGINT, this, "");

    /**
     * The column <code>DSR_STATISTICS.TOTAL_FUZZY</code>.
     */
    public final TableField<DsrStatisticsRecord, Long> TOTAL_FUZZY = createField("TOTAL_FUZZY", org.jooq.impl.SQLDataType.BIGINT, this, "");

    /**
     * The column <code>DSR_STATISTICS.TOTAL_MANUAL</code>.
     */
    public final TableField<DsrStatisticsRecord, Integer> TOTAL_MANUAL = createField("TOTAL_MANUAL", org.jooq.impl.SQLDataType.INTEGER, this, "");

    /**
     * The column <code>DSR_STATISTICS.SALES_LINE_RECOGNIZED</code>.
     */
    public final TableField<DsrStatisticsRecord, BigDecimal> SALES_LINE_RECOGNIZED = createField("SALES_LINE_RECOGNIZED", org.jooq.impl.SQLDataType.DECIMAL(60, 20), this, "");

    /**
     * Create a <code>DSR_STATISTICS</code> table reference
     */
    public DsrStatistics() {
        this(DSL.name("DSR_STATISTICS"), null);
    }

    /**
     * Create an aliased <code>DSR_STATISTICS</code> table reference
     */
    public DsrStatistics(String alias) {
        this(DSL.name(alias), DSR_STATISTICS);
    }

    /**
     * Create an aliased <code>DSR_STATISTICS</code> table reference
     */
    public DsrStatistics(Name alias) {
        this(alias, DSR_STATISTICS);
    }

    private DsrStatistics(Name alias, Table<DsrStatisticsRecord> aliased) {
        this(alias, aliased, null);
    }

    private DsrStatistics(Name alias, Table<DsrStatisticsRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""));
    }

    public <O extends Record> DsrStatistics(Table<O> child, ForeignKey<O, DsrStatisticsRecord> key) {
        super(child, key, DSR_STATISTICS);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Schema getSchema() {
        return DefaultSchema.DEFAULT_SCHEMA;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.DSR_STATISTICS_IX_DSR_STATISTICS_8055281B0DD3DFFB, Indexes.DSR_STATISTICS_PRIMARY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UniqueKey<DsrStatisticsRecord> getPrimaryKey() {
        return Keys.KEY_DSR_STATISTICS_PRIMARY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<UniqueKey<DsrStatisticsRecord>> getKeys() {
        return Arrays.<UniqueKey<DsrStatisticsRecord>>asList(Keys.KEY_DSR_STATISTICS_PRIMARY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public DsrStatistics as(String alias) {
        return new DsrStatistics(DSL.name(alias), this);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public DsrStatistics as(Name alias) {
        return new DsrStatistics(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public DsrStatistics rename(String name) {
        return new DsrStatistics(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public DsrStatistics rename(Name name) {
        return new DsrStatistics(name, null);
    }
}
